<?php

App::uses('BuzzSubscribeAppModel', 'BuzzSubscribe.Model');

class Subscriber extends BuzzSubscribeAppModel {

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'name' => array(
			'required' => array(
				'rule' => 'notEmpty',
				'message' => 'Required'
			),
			'maxLength' => array(
				'rule' => array('maxLength', 100),
				'message' => 'No more than 100 characters long'
			)
		),
		'first_name' => array(
			'required' => array(
				'rule' => 'notEmpty',
				'message' => 'Required'
			),
			'maxLength' => array(
				'rule' => array('maxLength', 45),
				'message' => 'No more than 45 characters long'
			)
		),
		'last_name' => array(
			'required' => array(
				'rule' => 'notEmpty',
				'message' => 'Required'
			),
			'maxLength' => array(
				'rule' => array('maxLength', 45),
				'message' => 'No more than 45 characters long'
			)
		),
		'email' => array(
			'required' => array(
				'rule' => 'notEmpty',
				'message' => 'Required'
			),
			'email' => array(
				'rule' => 'email',
				'message' => 'Not a valid email address'
			),
			'maxLength' => array(
				'rule' => array('maxLength', 254),
				'message' => 'No more than 254 characters long'
			)
		)
	);

/**
 * Before save logic
 *
 * @param array $options
 * @return bool
 */
	public function beforeSave($options = []) {
		if (!empty($this->data[$this->alias]['name'])) {
			if (preg_match('/^(\w+)\s(.*)/', $this->data[$this->alias]['name'], $matches) === 1) {
				$this->data[$this->alias]['first_name'] = $matches[1];
				$this->data[$this->alias]['last_name'] = $matches[2];
			} else {
				$this->data[$this->alias]['first_name'] = $this->data[$this->alias]['name'];
			}
		}
		return true;
	}

/**
 * After save logic
 *
 * @param bool $created
 * @param array $options
 * @return void
 */
	public function afterSave($created, $options = []) {
		parent::afterSave($created, $options);
		if ($created === true) {
			$Event = new CakeEvent('Model.Subscriber.created', $this, array(
				'id' => $this->id
			));
			$this->getEventManager()->dispatch($Event);
		}
		return;
	}

}
